using EVCB_OCPP.Packet.Features;
using EVCB_OCPP.Packet.Messages.SubTypes;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.Packet.Messages.Security
{
   public class InstallCertificateRequest:IRequest
    {
        public InstallCertificateRequest()
        {
            Action = Actions.InstallCertificate.ToString();
        }


        /// <summary>
        /// Indicates the certificate type that is sent.
        /// </summary>
        [Required]
        [JsonConverter(typeof(StringEnumConverter))]
        public CertificateUseEnumType certificateType { set; get; }

        /// <summary>
        /// An PEM encoded X.509 certificate.
        /// </summary>
        [Required]
        [StringLength(5500,MinimumLength =0)]
        public string certificate { set; get; }

        [JsonIgnore]
        public string Action { set; get; }

        public bool TransactionRelated()
        {
            return false;
        }

        public bool Validate()
        {
            return Validator.TryValidateObject(this, new ValidationContext(this), null, true);
        }
    }
}
